class Ball extends Entity {
  private float dx, dy;
  private float speed;
  private Paddle[] paddles;
  private ScoreKeeper score;
  
  public Ball(Paddle[] p, ScoreKeeper s) {
    super(width / 2, height / 2, 10, 10);
    dx = -1;
    dy = 0;
    speed = 5;
    paddles = p;
    score = s;
  }
  public void bounceX() {
    dx *= -1;
  }
  public void bounceY() {
    dy *= -1;
  }
  public void update() {
    checkCollisions();
    checkGoals();
    setX(getX() + dx * speed);
    setY(getY() + dy * speed);
  }
  public void checkCollisions() {
    for(Paddle paddle : paddles) {
      if(collide(paddle)) {
        bounceX();
        dy = -1 + 2*((getY() - paddle.getY())/paddle.getHeight());
      }
    }
    if(getY() < 0 || getY() > height)
      bounceY();
  }
  public void checkGoals() {
    if(getX() < 0) {
      score.opponentWin();
      setX(width/2);
    } else if(getX() > width) {
      score.playerWin();
      setX(width/2);
    }
  }
  public void render() {
    ellipse(getX(), getY(), getWidth(), getHeight());
  }
}
